# Make file generated by C17 WB
# This file should be placed directly under the project folder

# macro definitions for target file
TARGET= ayaka
GOAL= $(TARGET).elf

# macro definitions for tools
TOOL_DIR= C:/EPSON/C17WBIF
CC= $(TOOL_DIR)/xgcc
AS= $(TOOL_DIR)/xgcc
AS_CC= $(TOOL_DIR)/as
LD= $(TOOL_DIR)/ld
RM= $(TOOL_DIR)/rm
SED= $(TOOL_DIR)/sed
CP= $(TOOL_DIR)/cp
CC_KFILT= $(TOOL_DIR)/xgcc_filt
OBJDUMP= $(TOOL_DIR)/objdump
OBJCOPY= $(TOOL_DIR)/objcopy
MOTO2FF= $(TOOL_DIR)/moto2ff
SCONV= $(TOOL_DIR)/sconv32
VECCHECKER= $(TOOL_DIR)/vecChecker

# macro definitions for tool flags
CFLAGS= -B$(TOOL_DIR)/ -gstabs -S   -O1 -I$(TOOL_DIR)/include -fno-builtin -Wall  
ASFLAGS= -B$(TOOL_DIR)/ -c -xassembler-with-cpp -Wa,--gstabs  
ASFLAGS_CC=  
LDFLAGS=  -Map ayaka.map -N -T ayaka_gnu17IDE.lds  
EXTFLAGS= -Wa,-mc17_ext -Wa,$(TARGET).dump -Wa,$(TARGET).map
EXTFLAGS_CC= -mc17_ext $(TARGET).dump $(TARGET).map
OBJDUMPFLAGS= -t
OBJCOPYFLAGS= -I elf32-little -O srec --srec-forceS3
SCONVFLAGS= S2
VECCHECKERFLAGS= -t symtable.out -r raw.out
VECCHECKER_ON= false

# macro for switching 2pass or 1pass build
PASS= 2pass

# search paths for source files
vpath %.c 
vpath %.s 

# macro definitions for object files
OBJS= bg1-2.o \
      bg2-2.o \
      bg3-2.o \
      bg4-2.o \
      bg5-2.o \
      bg6-2.o \
      bg7-2.o \
      chr-2m.o \
      main.o \
      vector.o \
      
# macro definitions for library files
OBJLDS= $(TOOL_DIR)/lib/24bit/libstdio.a \
        $(TOOL_DIR)/lib/24bit/libc.a \
        $(TOOL_DIR)/lib/24bit/libgcc.a \
        $(TOOL_DIR)/lib/24bit/libc.a \
        
# macro definitions for assembly files generated from c source files
CEXTTEMPS= bg1-2.ext0 \
      bg2-2.ext0 \
      bg3-2.ext0 \
      bg4-2.ext0 \
      bg5-2.ext0 \
      bg6-2.ext0 \
      bg7-2.ext0 \
      chr-2m.ext0 \
      main.ext0 \
      

# macro definitions for dependency files
DEPS= $(OBJS:%.o=%.d)
SED_PTN= 's/[[:space:]]\([a-zA-Z]\)\:/ \/cygdrive\/\1/g'
SED_PTN2= 's/^\($(subst .,\.,$(@F))\)\:/$(subst /,\/,$(@))\:/g'

# macro definitions for creating dependency files
DEPCMD_CC= @$(CC_KFILT) -M -MG $(CFLAGS) $< | $(SED) -e $(SED_PTN) | $(SED) -e $(SED_PTN2) >$(@:%.o=%.d)
DEPCMD_AS= @$(AS) -M -MG $(ASFLAGS) $< | $(SED) -e $(SED_PTN) | $(SED) -e $(SED_PTN2) >$(@:%.o=%.d)

# targets and dependencies
.PHONY : all clean

all : $(GOAL)

$(TARGET).psa : $(TARGET).elf 
# clean psa files
	$(RM) -f $(TARGET).sa $(TARGET).saf $(TARGET).psa 
# create psa file from elf
	$(OBJCOPY) $(OBJCOPYFLAGS) $< $(TARGET).sa
	$(MOTO2FF) c000 18000 $(TARGET).sa 
	$(SCONV) $(SCONVFLAGS) $(TARGET).saf $(TARGET).psa
	@cmd /c "echo ---------------- Finished building target : $@ ----------------"

$(TARGET).elf : $(OBJS) ayaka_gnu17IDE.mak ayaka_gnu17IDE.lds
ifeq ($(PASS), 1pass)
# 1pass linking
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJLDS) 
else
# 1pass linking
	-$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJLDS) 2>lderr 
	@if [ -s lderr ]; then \
		cmd /c "type lderr" \
		&& $(RM) -f $(TARGET).elf \
		&& exit 1; \
	else $(RM) -f lderr ; \
	fi
	$(OBJDUMP) $(OBJDUMPFLAGS) $@ > $(TARGET).dump 
	$(RM) -f $(TARGET).elf 
# save 1pass object files
	@if [ -e obj1pass ]; then \
		cmd /c "rd /s /q obj1pass" ; \
	fi
	cmd /c "md obj1pass"
	for NAME in $(OBJS) ; do \
		$(CP) -pf $$NAME obj1pass/$$NAME ; done \
	&& $(RM) -f $(OBJS)
# 2pass for assembly files
	$(AS) $(ASFLAGS) $(EXTFLAGS) -o vector.o vector.s
# 2pass for c files
	for NAME in $(basename $(CEXTTEMPS))  ; do \
		$(AS_CC) $(ASFLAGS_CC) $(EXTFLAGS_CC) -o $$NAME.o $$NAME.ext0 ; done
	$(RM) -f $(TARGET).map 
# 2pass linking
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJLDS) 
# restore 1pass object files
	$(RM) -f $(OBJS) \
	&& \
	for NAME in $(OBJS) ; do \
		$(CP) -pf obj1pass/$$NAME $$NAME ; done \
	&& cmd /c "rd /s /q obj1pass"
endif

# check copro function in vector
ifeq ($(VECCHECKER_ON), true)
	$(RM) -f symtable.out raw.out
	$(OBJDUMP) -t $@ > symtable.out
	$(OBJDUMP) -s $@ > raw.out
	$(VECCHECKER) -t symtable.out -r raw.out
endif

	@cmd /c "echo ---------------- Finished building target : $@ ----------------"

## bg1-2.c
bg1-2.o : bg1-2.c bg1-2.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## bg2-2.c
bg2-2.o : bg2-2.c bg2-2.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## bg3-2.c
bg3-2.o : bg3-2.c bg3-2.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## bg4-2.c
bg4-2.o : bg4-2.c bg4-2.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## bg5-2.c
bg5-2.o : bg5-2.c bg5-2.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## bg6-2.c
bg6-2.o : bg6-2.c bg6-2.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## bg7-2.c
bg7-2.o : bg7-2.c bg7-2.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## chr-2m.c
chr-2m.o : chr-2m.c chr-2m.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## main.c
main.o : main.c main.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## vector.s
vector.o : vector.s
	$(AS) $(ASFLAGS) -o $@ $<
	$(DEPCMD_AS)


# dependecies for assembled c source files
bg1-2.ext0 : bg1-2.c
bg2-2.ext0 : bg2-2.c
bg3-2.ext0 : bg3-2.c
bg4-2.ext0 : bg4-2.c
bg5-2.ext0 : bg5-2.c
bg6-2.ext0 : bg6-2.c
bg7-2.ext0 : bg7-2.c
chr-2m.ext0 : chr-2m.c
main.ext0 : main.c

# include dependency files
-include $(DEPS)

# clean files
clean :
	$(RM) -f $(OBJS) $(TARGET).elf $(TARGET).map $(DEPS) $(CEXTTEMPS) $(TARGET).dump lderr $(TARGET).sa $(TARGET).saf $(TARGET).psa 
	@if [ -e obj1pass ]; then \
		cmd /c "rd /s /q obj1pass" ; \
	fi
