/*	
 *	S1C17702pU
 *
 *	Copyright (C) 2001-2009 Naoyuki Sawa
 *
 *	* Sun Dec 06 21:49:49 JST 2009 Naoyuki Sawa
 *	- 1st [XB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "s1c17702.h"

/*****************************************************************************
 *		
 *****************************************************************************/

unsigned long seed;
int now;

/*---------------------------------------------------------------------------*/

#define DISP_X	72	/* \̈ */
#define DISP_Y	32	/* \̈ */

unsigned char vbuff[DISP_Y][DISP_X];

extern unsigned char SRAM[(DISP_Y/*\̈*/ + 16/*gp̈*/) / 8][DISP_X/*\̈*/ + 24/*gp̈*/ + 160/*̈*/];
extern volatile int lcd_intc;
extern void make_dbuff();

/*****************************************************************************
 *	PAD	
 *****************************************************************************/

#define PAD_A		0x01	/* SW2 */
#define PAD_B		0x02	/* SW3 */
#define PAD_C		0x04	/* JP2 */
#define PAD_MASK	0x07
#define TRG_A		0x10	/* SW2 */
#define TRG_B		0x20	/* SW3 */
#define TRG_C		0x40	/* JP2 */
#define TRG_MASK	0x70

int pad;

/*---------------------------------------------------------------------------*/

void
pad_update()
{
	int val = ((P0_IN_P0IN >> 6) | ((P3_IN_P3IN & 1) << 2)) ^ 7;	/* 0 = on, 1 = off */
	int trg = (pad ^ val) & val;
	pad = val | (trg << 4);
}

/*****************************************************************************
 *	LED
 *****************************************************************************/

int led;	/* 0 = off, 1 = on */

/*---------------------------------------------------------------------------*/

void
led_update()
{
	if(led) {
		P2_OUT_P2OUT &= 0x7F;	/* 0 = on */
	} else {
		P2_OUT_P2OUT |= 0x80;	/* 1 = off */
	}
}

/*****************************************************************************
 *	P/ECE̕`惋[`ȗėp܂
 *****************************************************************************/

typedef struct _PIECE_VRAM {
	short w;			// +0,2
	short h;			// +2,2
	unsigned char* buf;		// +4,4
} PIECE_VRAM;				// =8

typedef struct _PBMP_FILEHEADER {
	unsigned long head;		// + 0,4
	unsigned long fsize;		// + 4,4
	unsigned char bpp;		// + 8,1
	unsigned char mask;		// + 9,1
	short w;			// +10,2
	short h;			// +12,2
	/* padding */			// +14,2
	unsigned long buf_size;		// +16,4
} PBMP_FILEHEADER;			// =20

typedef struct _PIECE_BMP {
	PBMP_FILEHEADER header;		// + 0,20
	unsigned char* buf;		// +20, 4
	unsigned char* mask;		// +24, 4
} PIECE_BMP;				// =28

typedef struct _RECTP {
	unsigned char left;		// +0,1
	unsigned char top;		// +1,1
	unsigned char right;		// +2,1
	unsigned char bottom;		// +3,1
} RECTP;				// =4

typedef struct _DRAW_OBJECT {
	const PIECE_VRAM* dest;		// + 0,4
	short dx;			// + 4,2
	short dy;			// + 6,2
	short dw;			// + 8,2
	short dh;			// +10,2
	const PIECE_BMP* src;		// +12,4
	short sx;			// +16,2
	short sy;			// +18,2
	RECTP clip;			// +20,4
	unsigned char disp;		// +24,1
	unsigned char param;		// +25,1
	unsigned char type;		// +26,1
	unsigned char layer;		// +27,1
} DRAW_OBJECT;				// =28

/*---------------------------------------------------------------------------*/

void
pceLCDSetObject(DRAW_OBJECT* obj, PIECE_BMP* src, int dx, int dy, int sx, int sy, int w, int h, int param)
{
	memset(obj, 0, sizeof(DRAW_OBJECT));
	obj->dx = dx;
	obj->dy = dy;
	obj->dw = w;
	obj->dh = h;
	obj->src = src;
	obj->sx = sx;
	obj->sy = sy;
	obj->clip.right = DISP_X;
	obj->clip.bottom = DISP_Y;
	obj->param = param;
}

/*---------------------------------------------------------------------------*/

static void
PDW_Draw_2BN(DRAW_OBJECT obj)
{
	int n = (obj.src->header.w * obj.sy + obj.sx) / 8;
	unsigned short* src_buf = (unsigned short*)obj.src->buf + n;
	unsigned char* src_mask = obj.src->mask + n;
	int src_stride = obj.src->header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
	unsigned char* dest_buf = obj.dest->buf + obj.dest->w * obj.dy + obj.dx;
	int dest_stride = obj.dest->w - obj.dw;
	int y = obj.dh;

	if(!obj.src->header.mask) {
		do {
			int step = obj.sx & 7;
			int pixel = *src_buf;
			int x = obj.dw;
			switch(step) {
LOOP_01:			pixel = *++src_buf;
#define PIXEL(p)	*dest_buf++ = pixel >> (p) * 2 & 3; if(--x == 0) break;
			case 0: PIXEL(3);
			case 1: PIXEL(2);
			case 2: PIXEL(1);
			case 3: PIXEL(0);
			case 4: PIXEL(7);
			case 5: PIXEL(6);
			case 6: PIXEL(5);
			default: PIXEL(4); goto LOOP_01;
#undef PIXEL
			}
			dest_buf += dest_stride;
			src_buf += src_stride;
		} while(--y != 0);
	} else {
		do {
			int step = obj.sx & 7;
			int pixel = *src_buf;
			int mask = *src_mask;
			int x = obj.dw;
			switch(step) {
LOOP_02:			pixel = *++src_buf;
				mask = *++src_mask;
#define PIXEL(p, m)	if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 2 & 3; dest_buf++; if(--x == 0) break;
			case 0: PIXEL(3, 7);
			case 1: PIXEL(2, 6);
			case 2: PIXEL(1, 5);
			case 3: PIXEL(0, 4);
			case 4: PIXEL(7, 3);
			case 5: PIXEL(6, 2);
			case 6: PIXEL(5, 1);
			default: PIXEL(4, 0); goto LOOP_02;
#undef PIXEL
			}
			dest_buf += dest_stride;
			src_buf += src_stride;
			src_mask += src_stride;
		} while(--y != 0);
	}
}

/*---------------------------------------------------------------------------*/

int
pceLCDDrawObject(DRAW_OBJECT obj)
{
	int x0;
	int y0;
	int x1;
	int y1;
	int n;

	if((obj.param != 0) || (obj.src->header.bpp != 2)) {
		return 0; /* Ή */
	}

	if(!obj.dest) {
		static const PIECE_VRAM dest = { DISP_X, DISP_Y, &vbuff[0][0] };
		obj.dest = &dest;
	}

	x0 = obj.clip.left > 0 ? obj.clip.left : 0;
	y0 = obj.clip.top > 0 ? obj.clip.top : 0;
	x1 = obj.clip.right < obj.dest->w ? obj.clip.right : obj.dest->w;
	y1 = obj.clip.bottom < obj.dest->h ? obj.clip.bottom : obj.dest->h;
	if(obj.dx < x0) { n = x0 - obj.dx; obj.dx = x0; obj.dw -= n; obj.sx += n; }
	if(obj.dx + obj.dw > x1) { obj.dw = x1 - obj.dx; }
	if(obj.dw <= 0) return 0;
	if(obj.dy < y0) { n = y0 - obj.dy; obj.dy = y0; obj.dh -= n; obj.sy += n; }
	if(obj.dy + obj.dh > y1) { obj.dh = y1 - obj.dy; }
	if(obj.dh <= 0) return 0;

	x1 = obj.src->header.w;
	y1 = obj.src->header.h;
	if(obj.sx < 0) { n = 0 - obj.sx; obj.sx = 0; obj.dw -= n; obj.dx += n; }
	if(obj.sx + obj.dw > x1) { obj.dw = x1 - obj.sx; }
	if(obj.dw <= 0) return 0;
	if(obj.sy < 0) { n = 0 - obj.sy; obj.sy = 0; obj.dh -= n; obj.dy += n; }
	if(obj.sy + obj.dh > y1) { obj.dh = y1 - obj.sy; }
	if(obj.dh <= 0) return 0;

	PDW_Draw_2BN(obj);

	return 1;
}

/*****************************************************************************
 *	
 *****************************************************************************/

void
init()
{
	MISC_FL_FLCYC = 4;	/* FLASHC read access cycle = 1 cycle */
	MISC_FL_SRCYC = 0;	/* SRAMC access cycle = 2 cycles (overclocking?) */

	PSC_CTL_PRUN = 1;	/* Prescaler run/stop control = Run */
	OSC_CTL_OSC3EN = 1;	/* OSC3 enable = Enable */
	OSC_SRC_HSCLKSEL = 1;	/* High-speed clock select = OSC3 */

	/* LED */
	P2_IO_P2IO |= 0x80;	/* P27 port output enable = Enable */

	/* LCD */
	OSC_LCLK_LCKDV = 3;	/* LCD clock division ratio select = HSCLK1/256 */
	OSC_LCLK_LCKSRC = 0;	/* LCD clock source select = HSCLK */
	OSC_LCLK_LCKEN = 1;	/* LCD clock enable = Enable */
	//
	LCD_CADJ_LC = 10;	/* LCD contrast adjustment = 10 */
	//
	LCD_DCTL_SEGREV = 0;	/* Segment output assignment control = Reverse */
	LCD_DCTL_COMREV = 0;	/* Common output assignment control = Reverse */
	LCD_DCTL_DSPREV = 0;	/* Reverse display control = Reverse */
	LCD_DCTL_DSPC = 1;	/* LCD display control = Normal display */
	//
	ITC_LV3_ILV6 = 1;	/* LCD interrupt level = 1 */
	LCD_IMSK_FRMIE = 1;	/* Frame signal interrupt enable = Enable */
}

/*****************************************************************************
 *	
 *****************************************************************************/

void
schedule()
{
	if(!(pad & PAD_C)) {	/* JP2V[g̓m[EFCg */
		static int cnt1;
		       int cnt2;
		do {
			cnt2 = lcd_intc;
		} while(cnt2 - cnt1 < 10/**/);	/* 6FPS */
		cnt1 = cnt2;
	}

	make_dbuff();
	led_update();
	pad_update();

	now++;
}

/*****************************************************************************
 *	
 *****************************************************************************/

extern const PBMP_FILEHEADER CHR;
extern const PBMP_FILEHEADER BG1;
extern const PBMP_FILEHEADER BG2;
extern const PBMP_FILEHEADER BG3;
extern const PBMP_FILEHEADER BG4;
extern const PBMP_FILEHEADER BG5;
extern const PBMP_FILEHEADER BG6;
extern const PBMP_FILEHEADER BG7;

static const PBMP_FILEHEADER* bg[7] = { &BG1,&BG2,&BG3,&BG4,&BG5,&BG6,&BG7 };
static const unsigned char ptn[6] = { 36*0,36*1,36*2,36*0,36*3,36*4 };

/*---------------------------------------------------------------------------*/

int
main()
{
	const PBMP_FILEHEADER* hdr;
	PIECE_BMP pbmp;
	DRAW_OBJECT obj;

	int bg_x = 0;
	int bg_sel = 0;
	int i_ptn = 0;


	for(;;) {
		led = 1;	/* LED_ */
		schedule();

		/* |[YAĊJ */
		if(pad & TRG_B) {
			do {
				led = (now / 3) & 1;	/* LED_ */
				schedule();
			} while(!(pad & TRG_MASK));
		}

		/* wiύX */
		if(pad & TRG_A) {
			bg_sel++;
			if(bg_sel == 7) {
				bg_sel = 0;
			}
		}

		/* wiXN[ */
		bg_x -= 4;
		if(bg_x == -64) {
			bg_x = 0;
		}

		/* LN^Aj[V */
		i_ptn++;
		if(i_ptn == 6) {
			i_ptn = 0;
		}

		/* wi` */
		hdr = bg[bg_sel];
		pbmp.header = *hdr;
		pbmp.buf = (unsigned char*)(hdr + 1);
		pbmp.mask = pbmp.buf + (hdr->h * hdr->w) / 4;
		//
		pceLCDSetObject(&obj, &pbmp, bg_x + (64 * 0), -6, 0, 0, 64, 44, 0);
		pceLCDDrawObject(obj);
		pceLCDSetObject(&obj, &pbmp, bg_x + (64 * 1), -6, 0, 0, 64, 44, 0);
		pceLCDDrawObject(obj);
		pceLCDSetObject(&obj, &pbmp, bg_x + (64 * 2), -6, 0, 0, 64, 44, 0);
		pceLCDDrawObject(obj);

		/* LN^` */
		hdr = &CHR;
		pbmp.header = *hdr;
		pbmp.buf = (unsigned char*)(hdr + 1);
		pbmp.mask = pbmp.buf + (hdr->h * hdr->w) / 4;
		//
		pceLCDSetObject(&obj, &pbmp, 24, -4, 0, ptn[i_ptn], 24, 36, 0);
		pceLCDDrawObject(obj);
	}

	return 0;
}

